/**
 *  Reader.cc
 */

#include "Reader.h"
#include "Database.h"
#include <iostream>

using namespace std;

Reader::Reader( int r, Database *db )
  : server(db)
  , readerNum(r)
{

}

void Reader::run()
{
  int c;

  while (true)
  {
    cout << "Leser " << readerNum << " schlummert\n";
    Database::napping();
    cout << "Leser " << readerNum << " will lesen\n";
    c = server->startRead();

    //Sie haben Lesezugriff auf die Datenbasis
    cout << "Leser " << readerNum << " liest, Zaehler =" << c << endl;
    Database::napping();
    c = server->endRead();
    cout << "Leser " << readerNum << " fertig mit Lesen, Zaehler =" << c << endl;
  }
}