/**
 *  Writer.cc
 */

#include "Writer.h"
#include "Database.h"
#include <iostream>

using namespace std;

Writer::Writer (int w, Database *db)
  : server(db)
  , writerNum(w)
{

}

void Writer::run()
{
  while (true)
  {
    cout << "Schreiber " << writerNum << " schlaeft\n";
    Database::napping();
    cout << "Schreiber " << writerNum << " will schreiben\n";
    server->startWrite();

    //Sie haben Schreibzugriff auf die Datenbasis
    cout << "Schreiber " << writerNum << " schreibt\n";
    Database::napping();
    server->endWrite();
    cout << "Schreiber " << writerNum << " fertig mit Schreiben\n";
  }
}