/**
 *  main.cc
 */

#include "Reader.h"
#include "Writer.h"
#include "Database.h"
#include <iostream>

using namespace std;

int main()
{
  Database database;
  int agentNo = 0;

  Writer writer(++agentNo, &database);
  Reader reader(++agentNo, &database);

  reader.start();
  writer.start();

  writer.join();
  reader.join();
}