#include <iostream>
#include "paging.h"
//#include <Trace.h>

//----------------------------------------------------------------------------------------------------------
// Threadklassen mit eigenem Adressraum
//
class MyThread_1 : public PagingNS::VMThread
{
  virtual void run ()
  {
    for (LogicalAddress i=0; i < 10; ++i) {
      mem(i+765) = '0'+i;
      mem(i+510) = 'a'+i;
      mem(i+250) = 'A'+i;
    }
    cout<<"-------------------------------\n";
    for ( LogicalAddress i=0; i < 10; ++i) {
      cout << "T1: " << mem(i+250) << "  ";
      cout << "T1: " << mem(i+510) << "  ";
      cout << "T1: " << mem(i+765) << endl;
    }

    for ( LogicalAddress i=0x0; i < 0x8000; ++i)
      mem(i) = '!';

    cout << "T1 fertig" << endl;
  }
};

class MyThread_2 : public PagingNS::VMThread
{
  virtual void run ()
  {
    for ( LogicalAddress i=0; i < 10; ++i) {
      mem(i+250) = 'A'+i;
      mem(i+510) = 'a'+i;
      mem(i+765) = '0'+i;
    }
    cout<<"-------------------------------\n";
    for ( LogicalAddress i=0; i < 10; ++i) {
      cout << "T2: " << mem(i+250) << "  ";
      cout << "T2: " << mem(i+510) << "  ";
      cout << "T2: " << mem(i+765) << endl;
    }
    for ( LogicalAddress i=0x1000; i < 0x9000; ++i)
      mem(i) = '?';
    cout << "T2 fertig" << endl;
  }
};

//----------------------------------------------------------------------------------------------------------
int main() {
//  Trace::doTrace = false;

  MyThread_1 t1;
  MyThread_2 t2;
  t1.start();
  t2.start();
  t1.join();
  t2.join();
}
