#include <iostream>

typedef unsigned long ulint;

struct A {
  char a[0x1000]; // 4096 Byte (4 kB)
};

void fStack (ulint &i) {
  A a;
  cout << i << ". im Stack an Pos: " << &a << endl;
  fStack( ++i );
}

void fHeap () {
  A *a;
  ulint i = 0;
  while ( true ) {
    a = new A;
    cout << dec << i << ". belegt Adresse " << hex << ulint(a) << endl;
    ++i;
  }
}

int main (int argc, char *argv[]) {
  ulint stackFrames = 0;
  if ( argc != 2 ) {
    cout << "Aufruf:\n " << argv[0] << " s : Stack-Test, oder\n " << argv[0] << " h : Heap-Test\n";
    exit(0);
  } 
  if (argv[1][0] == 's' ) fStack(stackFrames);
  else fHeap();
}
