/**
 *  PSemaphore.h
 */


#ifndef BS1_PSEMAPHORE_H
#define BS1_PSEMAPHORE_H

#include "PMutex.h"

namespace PThreadNS {

class PSemaphore
{
public:
  // Exceptions
  class Error { };

  PSemaphore();
  PSemaphore(int init);
  ~PSemaphore();

  void P();
  void V();

private:
  PMutex _pMutex;
  int _value;
};

} // namespace PThreadNS

#endif // BS1_PSEMAPHORE_H
