/**
 *  PThread.cc
 */

#include "PThread.h"

namespace PThreadNS {

PThread::PThread()
{

}

PThread::~PThread()
{
  join(); // or stop();
}

void PThread::start()
{
  pthread_create(&_thread, 0, run_wrapper, this);
}

void *PThread::run_wrapper(void *data)
{
  static_cast<PThread *>(data)->run();
  return 0;
}

void PThread::stop()
{
  throw NotImplemented();
}

void PThread::suspend()
{
  throw NotImplemented();
}

void PThread::resume()
{
  throw NotImplemented();
}

void PThread::join()
{
  pthread_join(_thread, 0);
}

} // namespace PThreadNS
