/**
 *  mysqrt.cc
 */

#include "mysqrt.h"

#include <cmath>

using namespace std;

double mysqrt(double x)
{
  double old, result = 1;
  
  do {
    old = result;
    result = (old + (x/old)) / 2;
  }
  while (fabs(old-result) > 1e-10);
  
  return result;
}