/**
 *  Database.h
 */

#ifndef DATABASE_H
#define DATABASE_H

#include <PSemaphore.h>

class Database
{
public:
  Database();

  int startRead();
  int endRead();
  void startWrite();
  void endWrite();

  static void napping();

private:
  static int NAP_TIME;
  int readerCount;

  PThreadNS::PSemaphore mutex;
  PThreadNS::PSemaphore db;
};

#endif // DATABASE_H
